%define anolis_release 1
# disable test because test_dwarfdumpPE.sh/test_dwarfdumpMacos.sh fail
%bcond_with tests

Name:          libdwarf
Epoch:         1
Version:       0.9.2
Release:       %{anolis_release}%{?dist}
Summary:       Library to access the DWARF Debugging file format

License:       LGPL-2.1-only AND BSD-2-Clause-FreeBSD
URL:           https://www.prevanders.net/dwarf.html
Source0:       https://www.prevanders.net/%{name}-%{version}.tar.xz

BuildRequires: gcc make python3

%description
Library to access the DWARF debugging file format which supports
source level debugging of a number of procedural languages, such as C, C++,
and Fortran.  Please see http://www.dwarfstd.org for DWARF specification.

%package devel
Summary:       Library and header files of libdwarf
License:       LGPL-2.1-only AND BSD-2-Clause-FreeBSD
Requires:      %{name} = %{epoch}:%{version}-%{release}

%description devel
Development package containing library and header files of libdwarf.

%package static
Summary:       Static libdwarf library
License:       LGPL-2.1-only AND BSD-2-Clause-FreeBSD
Requires:      %{name}-devel = %{epoch}:%{version}-%{release}

%description static
Static libdwarf library.

%package tools
Summary:       Tools for accessing DWARF debugging information
License:       GPL-2.0-only AND BSD-2-Clause-FreeBSD
Requires:      %{name} = %{epoch}:%{version}-%{release}

%description tools
C++ version of dwarfdump (dwarfdump2) command-line utilities
to access DWARF debug information.

%package        doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1

%build
%configure --enable-shared
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool
%make_build

%install
%make_install
%generate_compatibility_deps

%check
%if %{with tests}
TZ=:America/Los_Angeles %__make check
%endif

%files
%license src/lib/libdwarf/COPYING src/lib/libdwarf/LIBDWARFCOPYRIGHT src/lib/libdwarf/LGPL.txt
%{_libdir}/libdwarf.so.0
%{_libdir}/libdwarf.so.0.*
%dir %{abidir}
%{abidir}/libdwarf.dump

%files static
%{_libdir}/libdwarf.a

%files devel
%doc doc/*.pdf
%{_includedir}/libdwarf-0
%{_libdir}/libdwarf.so
%{_libdir}/pkgconfig/libdwarf.pc

%files tools
%license src/bin/dwarfdump/COPYING src/bin/dwarfdump/DWARFDUMPCOPYRIGHT src/bin/dwarfdump/GPL.txt
%{_bindir}/dwarfdump
%{abidir}/dwarfdump-option.list
%{_datadir}/dwarfdump/dwarfdump.conf
%{_mandir}/man1/dwarfdump.1.zst

%files doc
%doc src/lib/libdwarf/ChangeLog src/lib/libdwarf/README

%changelog
* Tue May 28 2024 mgb01105731 <mgb01105731@alibaba-inc.com> - 0.9.2-1
- update to 0.9.2

* Sat Mar 25 2023 Yuanhong Peng <yummypeng@linux.alibaba.com> - 0.6.0-1
- Init from upstream
